(define-module (ui net-wifi ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :use-module (alterator algo)
    :export (init))

;; update list, keep previous value or set the first one, return value
(define (mysplit str)
  (string-split (if (string? str) str "") #\;) )
(define (form-update-enum-smart name d)
    (let* ((v (cond-car (mysplit
                (or (form-value name)
                    (if (pair? d) (woo-get-option (cond-car d) (string->symbol name))) )))))
      (form-update-enum  name d)
      (form-update-value name v)
      v))

(define (update-activity)
  (let ((auth (form-value "auth_type")))
    (form-update-activity "key"      (not (string=? auth "nopasswd")) )
    (form-update-activity "pairwise" (not (or (string=? auth "nopasswd")
                                            (string=? auth "wep")))) ))
(define (on-change)
  (form-update-value-list '("enabled" "essid" "current" "auth_type" "pairwise")
    (woo-read-first "/net-wifi" 'iface (form-value "iface") 'name (form-value "name")))
    (update-activity))

(define (update-status)
  (form-update-value-list `("iface_status")
    (woo-read-first "/net-wifi" 'iface (form-value "iface")))
  (form-update-enum-smart "name"
    (woo-list "/net-wifi/networks" 'iface (form-value "iface")))
  (form-set-timeout update-status 2))

(define (init)
  (form-bind "name" "change"  on-change)
  (form-bind "auth_type" "change" update-activity)
  (update-activity)
  (update-status))
